"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:dragonfly/c1' }"

"{ NameSpace: DragonFly }"

Array variableSubclass:#C1Context
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DragonFly-C1'
!

!C1Context class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.

"
! !

!C1Context class methodsFor:'instance creation'!

forMethod: aMethod
    | numArgs numVars arg0Index context |

    numArgs := aMethod numArgs.
    numVars := aMethod numVars.
    arg0Index := aMethod isStatic ifTrue:[0] ifFalse:[1].
    context  := self new: arg0Index + numArgs + numVars + aMethod stackSize.
    aMethod isJavaMethod ifTrue:[ 
        | descriptor i |

        i := 1.
        aMethod isStatic ifFalse:[ 
            context at: 1 put: (C1ReferenceValue new setSpilled: true).
            i := 2.
        ].
        descriptor := aMethod descriptor.
        descriptor parameters do:[:param | 
            (#('byte' 'short' 'int' 'char' 'boolean') includes: param javaClassName) ifTrue:[ 
                context at: i put: (C1Int32Value new setSpilled: true).
            ] ifFalse:[
            'long' = param javaClassName ifTrue:[ 
                context at: i put: (C1Int64Value new setSpilled: true).
                i := i + 1.
            ] ifFalse:[
            'float' = param javaClassName ifTrue:[ 
                context at: i put: (C1FloatValue new setSpilled: true).
            ] ifFalse:[
            'double' = param javaClassName ifTrue:[ 
                context at: i put: (C1DoubleValue new setSpilled: true).
                i := i + 1.                 
            ] ifFalse:[
                context at: i put: (C1ReferenceValue new setSpilled: true).
            ]]]].
            i := i + 1.
        ].
    ] ifFalse:[ 
        self notYetImplemented.
    ].    
    ^ context

    "Created: / 31-07-2016 / 07:42:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-08-2016 / 11:03:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1Context methodsFor:'accessing'!

at: index put: anObject
    self assert: (anObject isKindOf: C1Value).
    anObject setContext: self.
    ^ super at: index put: anObject.

    "Created: / 31-07-2016 / 08:56:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-08-2016 / 22:28:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

