"
    Copyright (c) 2016-now, Jan Vrany <jan . vrany [at] fit . cvut . cz>
    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, 
    are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, 
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice, 
       this list of conditions and the following disclaimer in the documentation 
       and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 'AS IS' AND 
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
    ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"
"{ Package: 'jv:dragonfly/udis86sx' }"

"{ NameSpace: Smalltalk }"

SharedPool subclass:#UDIS86Types
	instanceVariableNames:''
	classVariableNames:'UD_NONE UD_R_AL UD_R_CL UD_R_DL UD_R_BL UD_R_AH UD_R_CH UD_R_DH
		UD_R_BH UD_R_SPL UD_R_BPL UD_R_SIL UD_R_DIL UD_R_R8B UD_R_R9B
		UD_R_R10B UD_R_R11B UD_R_R12B UD_R_R13B UD_R_R14B UD_R_R15B
		UD_R_AX UD_R_CX UD_R_DX UD_R_BX UD_R_SP UD_R_BP UD_R_SI UD_R_DI
		UD_R_R8W UD_R_R9W UD_R_R10W UD_R_R11W UD_R_R12W UD_R_R13W
		UD_R_R14W UD_R_R15W UD_R_EAX UD_R_ECX UD_R_EDX UD_R_EBX UD_R_ESP
		UD_R_EBP UD_R_ESI UD_R_EDI UD_R_R8D UD_R_R9D UD_R_R10D UD_R_R11D
		UD_R_R12D UD_R_R13D UD_R_R14D UD_R_R15D UD_R_RAX UD_R_RCX
		UD_R_RDX UD_R_RBX UD_R_RSP UD_R_RBP UD_R_RSI UD_R_RDI UD_R_R8
		UD_R_R9 UD_R_R10 UD_R_R11 UD_R_R12 UD_R_R13 UD_R_R14 UD_R_R15
		UD_R_ES UD_R_CS UD_R_SS UD_R_DS UD_R_FS UD_R_GS UD_R_CR0 UD_R_CR1
		UD_R_CR2 UD_R_CR3 UD_R_CR4 UD_R_CR5 UD_R_CR6 UD_R_CR7 UD_R_CR8
		UD_R_CR9 UD_R_CR10 UD_R_CR11 UD_R_CR12 UD_R_CR13 UD_R_CR14
		UD_R_CR15 UD_R_DR0 UD_R_DR1 UD_R_DR2 UD_R_DR3 UD_R_DR4 UD_R_DR5
		UD_R_DR6 UD_R_DR7 UD_R_DR8 UD_R_DR9 UD_R_DR10 UD_R_DR11 UD_R_DR12
		UD_R_DR13 UD_R_DR14 UD_R_DR15 UD_R_MM0 UD_R_MM1 UD_R_MM2 UD_R_MM3
		UD_R_MM4 UD_R_MM5 UD_R_MM6 UD_R_MM7 UD_R_ST0 UD_R_ST1 UD_R_ST2
		UD_R_ST3 UD_R_ST4 UD_R_ST5 UD_R_ST6 UD_R_ST7 UD_R_XMM0 UD_R_XMM1
		UD_R_XMM2 UD_R_XMM3 UD_R_XMM4 UD_R_XMM5 UD_R_XMM6 UD_R_XMM7
		UD_R_XMM8 UD_R_XMM9 UD_R_XMM10 UD_R_XMM11 UD_R_XMM12 UD_R_XMM13
		UD_R_XMM14 UD_R_XMM15 UD_R_RIP UD_OP_REG UD_OP_MEM UD_OP_PTR
		UD_OP_IMM UD_OP_JIMM UD_OP_CONST'
	poolDictionaries:''
	category:'UDIS86'
!

!UDIS86Types primitiveDefinitions!
%{

/*
 * includes, defines, structure definitions
 * and typedefs come here.
 */

#include <udis86.h>

%}
! !

!UDIS86Types class methodsFor:'documentation'!

copyright
"
    Copyright (c) 2016-now, Jan Vrany <jan . vrany [at] fit . cvut . cz>
    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, 
    are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, 
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice, 
       this list of conditions and the following disclaimer in the documentation 
       and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 'AS IS' AND 
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
    ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

"
! !

!UDIS86Types class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    | v |

%{
    v = __MKSMALLINT( UD_NONE );
%}.
    UD_NONE := v.
%{
    v = __MKSMALLINT( UD_R_AL );
%}.
    UD_R_AL := v.
%{
    v = __MKSMALLINT( UD_R_CL );
%}.
    UD_R_CL := v.
%{
    v = __MKSMALLINT( UD_R_DL );
%}.
    UD_R_DL := v.
%{
    v = __MKSMALLINT( UD_R_BL );
%}.
    UD_R_BL := v.
%{
    v = __MKSMALLINT( UD_R_AH );
%}.
    UD_R_AH := v.
%{
    v = __MKSMALLINT( UD_R_CH );
%}.
    UD_R_CH := v.
%{
    v = __MKSMALLINT( UD_R_DH );
%}.
    UD_R_DH := v.
%{
    v = __MKSMALLINT( UD_R_BH );
%}.
    UD_R_BH := v.
%{
    v = __MKSMALLINT( UD_R_SPL );
%}.
    UD_R_SPL := v.
%{
    v = __MKSMALLINT( UD_R_BPL );
%}.
    UD_R_BPL := v.
%{
    v = __MKSMALLINT( UD_R_SIL );
%}.
    UD_R_SIL := v.
%{
    v = __MKSMALLINT( UD_R_DIL );
%}.
    UD_R_DIL := v.
%{
    v = __MKSMALLINT( UD_R_R8B );
%}.
    UD_R_R8B := v.
%{
    v = __MKSMALLINT( UD_R_R9B );
%}.
    UD_R_R9B := v.
%{
    v = __MKSMALLINT( UD_R_R10B );
%}.
    UD_R_R10B := v.
%{
    v = __MKSMALLINT( UD_R_R11B );
%}.
    UD_R_R11B := v.
%{
    v = __MKSMALLINT( UD_R_R12B );
%}.
    UD_R_R12B := v.
%{
    v = __MKSMALLINT( UD_R_R13B );
%}.
    UD_R_R13B := v.
%{
    v = __MKSMALLINT( UD_R_R14B );
%}.
    UD_R_R14B := v.
%{
    v = __MKSMALLINT( UD_R_R15B );
%}.
    UD_R_R15B := v.
%{
    v = __MKSMALLINT( UD_R_AX );
%}.
    UD_R_AX := v.
%{
    v = __MKSMALLINT( UD_R_CX );
%}.
    UD_R_CX := v.
%{
    v = __MKSMALLINT( UD_R_DX );
%}.
    UD_R_DX := v.
%{
    v = __MKSMALLINT( UD_R_BX );
%}.
    UD_R_BX := v.
%{
    v = __MKSMALLINT( UD_R_SP );
%}.
    UD_R_SP := v.
%{
    v = __MKSMALLINT( UD_R_BP );
%}.
    UD_R_BP := v.
%{
    v = __MKSMALLINT( UD_R_SI );
%}.
    UD_R_SI := v.
%{
    v = __MKSMALLINT( UD_R_DI );
%}.
    UD_R_DI := v.
%{
    v = __MKSMALLINT( UD_R_R8W );
%}.
    UD_R_R8W := v.
%{
    v = __MKSMALLINT( UD_R_R9W );
%}.
    UD_R_R9W := v.
%{
    v = __MKSMALLINT( UD_R_R10W );
%}.
    UD_R_R10W := v.
%{
    v = __MKSMALLINT( UD_R_R11W );
%}.
    UD_R_R11W := v.
%{
    v = __MKSMALLINT( UD_R_R12W );
%}.
    UD_R_R12W := v.
%{
    v = __MKSMALLINT( UD_R_R13W );
%}.
    UD_R_R13W := v.
%{
    v = __MKSMALLINT( UD_R_R14W );
%}.
    UD_R_R14W := v.
%{
    v = __MKSMALLINT( UD_R_R15W );
%}.
    UD_R_R15W := v.

%{
    v = __MKSMALLINT( UD_R_EAX );
%}.
    UD_R_EAX := v.
%{
    v = __MKSMALLINT( UD_R_ECX );
%}.
    UD_R_ECX := v.
%{
    v = __MKSMALLINT( UD_R_EDX );
%}.
    UD_R_EDX := v.
%{
    v = __MKSMALLINT( UD_R_EBX );
%}.
    UD_R_EBX := v.

%{
    v = __MKSMALLINT( UD_R_ESP );
%}.
    UD_R_ESP := v.
%{
    v = __MKSMALLINT( UD_R_EBP );
%}.
    UD_R_EBP := v.
%{
    v = __MKSMALLINT( UD_R_ESI );
%}.
    UD_R_ESI := v.
%{
    v = __MKSMALLINT( UD_R_EDI );
%}.
    UD_R_EDI := v.

%{
    v = __MKSMALLINT( UD_R_R8D );
%}.
    UD_R_R8D := v.
%{
    v = __MKSMALLINT( UD_R_R9D );
%}.
    UD_R_R9D := v.
%{
    v = __MKSMALLINT( UD_R_R10D );
%}.
    UD_R_R10D := v.
%{
    v = __MKSMALLINT( UD_R_R11D );
%}.
    UD_R_R11D := v.

%{
    v = __MKSMALLINT( UD_R_R12D );
%}.
    UD_R_R12D := v.
%{
    v = __MKSMALLINT( UD_R_R13D );
%}.
    UD_R_R13D := v.
%{
    v = __MKSMALLINT( UD_R_R14D );
%}.
    UD_R_R14D := v.
%{
    v = __MKSMALLINT( UD_R_R15D );
%}.
    UD_R_R15D := v.

%{
    v = __MKSMALLINT( UD_R_RAX );
%}.
    UD_R_RAX := v.
%{
    v = __MKSMALLINT( UD_R_RCX );
%}.
    UD_R_RCX := v.
%{
    v = __MKSMALLINT( UD_R_RDX );
%}.
    UD_R_RDX := v.
%{
    v = __MKSMALLINT( UD_R_RBX );
%}.
    UD_R_RBX := v.

%{
    v = __MKSMALLINT( UD_R_RSP );
%}.
    UD_R_RSP := v.
%{
    v = __MKSMALLINT( UD_R_RBP );
%}.
    UD_R_RBP := v.
%{
    v = __MKSMALLINT( UD_R_RSI );
%}.
    UD_R_RSI := v.
%{
    v = __MKSMALLINT( UD_R_RDI );
%}.
    UD_R_RDI := v.

%{
    v = __MKSMALLINT( UD_R_R8 );
%}.
    UD_R_R8 := v.
%{
    v = __MKSMALLINT( UD_R_R9 );
%}.
    UD_R_R9 := v.
%{
    v = __MKSMALLINT( UD_R_R10 );
%}.
    UD_R_R10 := v.
%{
    v = __MKSMALLINT( UD_R_R11 );
%}.
    UD_R_R11 := v.

%{
    v = __MKSMALLINT( UD_R_R12 );
%}.
    UD_R_R12 := v.
%{
    v = __MKSMALLINT( UD_R_R13 );
%}.
    UD_R_R13 := v.
%{
    v = __MKSMALLINT( UD_R_R14 );
%}.
    UD_R_R14 := v.
%{
    v = __MKSMALLINT( UD_R_R15 );
%}.
    UD_R_R15 := v.

%{
    v = __MKSMALLINT( UD_R_ES );
%}.
    UD_R_ES := v.
%{
    v = __MKSMALLINT( UD_R_CS );
%}.
    UD_R_CS := v.
%{
    v = __MKSMALLINT( UD_R_SS );
%}.
    UD_R_SS := v.
%{
    v = __MKSMALLINT( UD_R_DS );
%}.
    UD_R_DS := v.

%{
    v = __MKSMALLINT( UD_R_FS );
%}.
    UD_R_FS := v.
%{
    v = __MKSMALLINT( UD_R_GS );
%}.
    UD_R_GS := v.

%{
    v = __MKSMALLINT( UD_R_CR0 );
%}.
    UD_R_CR0 := v.
%{
    v = __MKSMALLINT( UD_R_CR1 );
%}.
    UD_R_CR1 := v.
%{
    v = __MKSMALLINT( UD_R_CR2 );
%}.
    UD_R_CR2 := v.
%{
    v = __MKSMALLINT( UD_R_CR3 );
%}.
    UD_R_CR3 := v.

%{
    v = __MKSMALLINT( UD_R_CR4 );
%}.
    UD_R_CR4 := v.
%{
    v = __MKSMALLINT( UD_R_CR5 );
%}.
    UD_R_CR5 := v.
%{
    v = __MKSMALLINT( UD_R_CR6 );
%}.
    UD_R_CR6 := v.
%{
    v = __MKSMALLINT( UD_R_CR7 );
%}.
    UD_R_CR7 := v.

%{
    v = __MKSMALLINT( UD_R_CR8 );
%}.
    UD_R_CR8 := v.
%{
    v = __MKSMALLINT( UD_R_CR9 );
%}.
    UD_R_CR9 := v.
%{
    v = __MKSMALLINT( UD_R_CR10 );
%}.
    UD_R_CR10 := v.
%{
    v = __MKSMALLINT( UD_R_CR11 );
%}.
    UD_R_CR11 := v.

%{
    v = __MKSMALLINT( UD_R_CR12 );
%}.
    UD_R_CR12 := v.
%{
    v = __MKSMALLINT( UD_R_CR13 );
%}.
    UD_R_CR13 := v.
%{
    v = __MKSMALLINT( UD_R_CR14 );
%}.
    UD_R_CR14 := v.
%{
    v = __MKSMALLINT( UD_R_CR15 );
%}.
    UD_R_CR15 := v.

%{
    v = __MKSMALLINT( UD_R_DR0 );
%}.
    UD_R_DR0 := v.
%{
    v = __MKSMALLINT( UD_R_DR1 );
%}.
    UD_R_DR1 := v.
%{
    v = __MKSMALLINT( UD_R_DR2 );
%}.
    UD_R_DR2 := v.
%{
    v = __MKSMALLINT( UD_R_DR3 );
%}.
    UD_R_DR3 := v.

%{
    v = __MKSMALLINT( UD_R_DR4 );
%}.
    UD_R_DR4 := v.
%{
    v = __MKSMALLINT( UD_R_DR5 );
%}.
    UD_R_DR5 := v.
%{
    v = __MKSMALLINT( UD_R_DR6 );
%}.
    UD_R_DR6 := v.
%{
    v = __MKSMALLINT( UD_R_DR7 );
%}.
    UD_R_DR7 := v.

%{
    v = __MKSMALLINT( UD_R_DR8 );
%}.
    UD_R_DR8 := v.
%{
    v = __MKSMALLINT( UD_R_DR9 );
%}.
    UD_R_DR9 := v.
%{
    v = __MKSMALLINT( UD_R_DR10 );
%}.
    UD_R_DR10 := v.
%{
    v = __MKSMALLINT( UD_R_DR11 );
%}.
    UD_R_DR11 := v.

%{
    v = __MKSMALLINT( UD_R_DR12 );
%}.
    UD_R_DR12 := v.
%{
    v = __MKSMALLINT( UD_R_DR13 );
%}.
    UD_R_DR13 := v.
%{
    v = __MKSMALLINT( UD_R_DR14 );
%}.
    UD_R_DR14 := v.
%{
    v = __MKSMALLINT( UD_R_DR15 );
%}.
    UD_R_DR15 := v.

%{
    v = __MKSMALLINT( UD_R_MM0 );
%}.
    UD_R_MM0 := v.
%{
    v = __MKSMALLINT( UD_R_MM1 );
%}.
    UD_R_MM1 := v.
%{
    v = __MKSMALLINT( UD_R_MM2 );
%}.
    UD_R_MM2 := v.
%{
    v = __MKSMALLINT( UD_R_MM3 );
%}.
    UD_R_MM3 := v.

%{
    v = __MKSMALLINT( UD_R_MM4 );
%}.
    UD_R_MM4 := v.
%{
    v = __MKSMALLINT( UD_R_MM5 );
%}.
    UD_R_MM5 := v.
%{
    v = __MKSMALLINT( UD_R_MM6 );
%}.
    UD_R_MM6 := v.
%{
    v = __MKSMALLINT( UD_R_MM7 );
%}.
    UD_R_MM7 := v.

%{
    v = __MKSMALLINT( UD_R_ST0 );
%}.
    UD_R_ST0 := v.
%{
    v = __MKSMALLINT( UD_R_ST1 );
%}.
    UD_R_ST1 := v.
%{
    v = __MKSMALLINT( UD_R_ST2 );
%}.
    UD_R_ST2 := v.
%{
    v = __MKSMALLINT( UD_R_ST3 );
%}.
    UD_R_ST3 := v.

%{
    v = __MKSMALLINT( UD_R_ST4 );
%}.
    UD_R_ST4 := v.
%{
    v = __MKSMALLINT( UD_R_ST5 );
%}.
    UD_R_ST5 := v.
%{
    v = __MKSMALLINT( UD_R_ST6 );
%}.
    UD_R_ST6 := v.
%{
    v = __MKSMALLINT( UD_R_ST7 );
%}.
    UD_R_ST7 := v.

%{
    v = __MKSMALLINT( UD_R_XMM0 );
%}.
    UD_R_XMM0 := v.
%{
    v = __MKSMALLINT( UD_R_XMM1 );
%}.
    UD_R_XMM1 := v.
%{
    v = __MKSMALLINT( UD_R_XMM2 );
%}.
    UD_R_XMM2 := v.
%{
    v = __MKSMALLINT( UD_R_XMM3 );
%}.
    UD_R_XMM3 := v.

%{
    v = __MKSMALLINT( UD_R_XMM4 );
%}.
    UD_R_XMM4 := v.
%{
    v = __MKSMALLINT( UD_R_XMM5 );
%}.
    UD_R_XMM5 := v.
%{
    v = __MKSMALLINT( UD_R_XMM6 );
%}.
    UD_R_XMM6 := v.
%{
    v = __MKSMALLINT( UD_R_XMM7 );
%}.
    UD_R_XMM7 := v.

%{
    v = __MKSMALLINT( UD_R_XMM8 );
%}.
    UD_R_XMM8 := v.
%{
    v = __MKSMALLINT( UD_R_XMM9 );
%}.
    UD_R_XMM9 := v.
%{
    v = __MKSMALLINT( UD_R_XMM10 );
%}.
    UD_R_XMM10 := v.
%{
    v = __MKSMALLINT( UD_R_XMM11 );
%}.
    UD_R_XMM11 := v.

%{
    v = __MKSMALLINT( UD_R_XMM12 );
%}.
    UD_R_XMM12 := v.
%{
    v = __MKSMALLINT( UD_R_XMM13 );
%}.
    UD_R_XMM13 := v.
%{
    v = __MKSMALLINT( UD_R_XMM14 );
%}.
    UD_R_XMM14 := v.
%{
    v = __MKSMALLINT( UD_R_XMM15 );
%}.
    UD_R_XMM15 := v.

%{
    v = __MKSMALLINT( UD_R_RIP );
%}.
    UD_R_RIP := v.

%{
    v = __MKSMALLINT( UD_OP_REG );
%}.
    UD_OP_REG := v.
%{
    v = __MKSMALLINT( UD_OP_MEM );
%}.
    UD_OP_MEM := v.
%{
    v = __MKSMALLINT( UD_OP_PTR );
%}.
    UD_OP_PTR := v.
%{
    v = __MKSMALLINT( UD_OP_IMM );
%}.
    UD_OP_IMM := v.

%{
    v = __MKSMALLINT( UD_OP_JIMM );
%}.
    UD_OP_JIMM := v.
%{
    v = __MKSMALLINT( UD_OP_CONST );
%}.
    UD_OP_CONST := v.



! !


UDIS86Types initialize!
